2012-04-11  frankmorgner

	* [r755] configure.ac, doc/Makefile.am, src/Makefile.am: use macro
	  for sed im makefiles

	* [r746] doc/README.rst, doc/README.rst.in: fixed sphinx warning

	* [r743] doc/Makefile.am, doc/README.rst, doc/README.rst.in:
	  updated documentation

2012-04-10  frankmorgner

	* [r742] src/Makefile.am: removed reference to pcscutil.h, which is
	  now part of pcsc-relay

	* [r741] src/pcscutil.c[DEL], src/pcscutil.h[DEL]: stringify_error
	  now returns a string instead of printing the error

	* [r739] configure.ac, src/Makefile.am, src/ccid-emulator.ggo.in:
	  use help2man to generate minimal man pages

	* [r737] src/Makefile.am, src/binutil.c[DEL], src/binutil.h[DEL],
	  src/ccid-emulator.ggo.in, src/usb.c: switched to command line
	  handling with gengetopt

2012-04-09  frankmorgner

	* [r735] doc/README.rst, doc/autotools.rst: updated documentation

	* [r734] configure.ac: more readable information via autoconf

2012-03-02  frankmorgner

	* [r727] doc/Makefile.am: added recommended configure options to
	  documentation

2012-02-26  frankmorgner

	* [r724] src/Makefile.am: follow symbolic links when searching for
	  openscs header files

2012-02-17  frankmorgner

	* [r718] configure.ac, src/ccid.c: get ef.cardaccess on demand.
	  newer versions of ausweisapp dont screw this up anymore.

2012-01-31  frankmorgner

	* [r700] configure.ac: fixed output of configure variables for
	  libnpa

2012-01-25  frankmorgner

	* [r696] configure.ac, src/Makefile.am, src/cats-test.c[DEL],
	  src/ccid.c: using patched OpenSC enabled with PACE to use the
	  reader's capabilities
	  
	  sourcecode can be fetched from here
	  https://github.com/frankmorgner/OpenSC

2012-01-24  frankmorgner

	* [r694] patches/ccid-1.3.11.patch, patches/ccid-1.4.4.patch,
	  patches/ccid-1.4.5.patch: raise temporary buffer size to the
	  maximum possible for pace

	* [r693] patches/ccid-1.3.11.patch, patches/ccid-1.4.4.patch,
	  patches/ccid-1.4.5.patch: add support for big certificate
	  descriptions

2011-12-06  frankmorgner

	* [r638] patches/ccid-1.3.11.patch: added defines to cope with
	  unpatched pcsc libraries

2011-11-08  frankmorgner

	* [r635] doc/README.rst, doc/README.rst.in: not using static path
	  for program-output. instead setting the correct envirnment in
	  conf.py.

2011-11-05  frankmorgner

	* [r627] doc/Makefile.am, doc/README.rst, doc/README.rst.in:
	  included help output from programs in documentation

	* [r625] doc/Makefile.am: cleaned up build of documentation

2011-11-04  frankmorgner

	* [r614] src/cats-test.c: added chat for signature terminal and
	  some error codes

2011-11-03  frankmorgner

	* [r613] doc/Makefile.am, doc/README.rst, doc/README.rst.in: -
	  update on ccid documentation - rebuilding documentation when any
	  *.in file changes

2011-11-02  frankmorgner

	* [r606] doc/README.rst, doc/autotools.rst, doc/questions.rst:
	  added autogenerated files for easier development checkout

2011-11-01  frankmorgner

	* [r605] doc/Makefile.am: only refresh documentation if needed

2011-10-29  frankmorgner

	* [r599] doc/Makefile.am, doc/README.rst[DEL],
	  doc/README.rst.in[CPY]: more autotool magic

	* [r597] Makefile.am, configure.ac, doc/Makefile.am: - more
	  autotool magic in documentation files - including substituted
	  documentation files with distributed files

	* [r595] doc/Makefile.am, doc/README.rst, doc/questions.rst.in: -
	  worked around warnings of sphinx - using generic file for
	  questions for all subprojects

	* [r594] doc/README.rst: documentation

	* [r591] Makefile.am, doc/Makefile.am, doc/README.rst,
	  doc/autotools.rst.in: using generic autotools description for all
	  subprojects

2011-10-28  frankmorgner

	* [r590] doc/README.rst: added more markup

2011-10-27  frankmorgner

	* [r587] Makefile.am, README, README.dox[DEL], configure.ac, doc,
	  doc/Makefile.am, doc/README.rst[CPY]: using a dedicated folder
	  for documentation in each subproject

	* [r586] README.dox: documentation

2011-10-27  oepen

	* [r585] README.dox: -Better install instructions for ccid-emulator
	  -Added metadata to documentation

2011-10-23  frankmorgner

	* [r564] README.dox:

2011-10-22  frankmorgner

	* [r561] Doxyfile.in[DEL], Makefile.am, configure.ac: dont generate
	  sourcecode documentation for binaries

2011-10-14  oepen

	* [r553] Doxyfile.in: Fix __attribute__ handling of doxygen

2011-10-13  oepen

	* [r551] Doxyfile.in, README.dox: -Removed README.dox from ccid
	  Doxyfile inputs -Started to use breathe to integrate Doxygen
	  documentation into sphinx

	* [r550] Doxyfile.in: -Exclude OpenSC from documentation -Enable
	  XML documentation generation for sphinx

2011-10-12  oepen

	* [r544] README.dox: Converted ccid documentation to
	  reStructuredText

2011-09-26  frankmorgner

	* [r539] apdus[DEL]: - moved example apdus to npa-tool

2011-09-20  frankmorgner

	* [r534] src/ccid.c: handling certificate description and chat in
	  libnpa instead of ccid-emulator

	* [r533] src/ccid.c: checking certificate description on pso:verify
	  certificate

	* [r532] src/ccid.c: dumping chat

	* [r531] src/ccid.c: dumping certificate description

2011-09-14  frankmorgner

	* [r529] src/ccid.c: added ugly hack to support changing the
	  eID-PIN with AusweisApp

	* [r528] src/ccid.c: fixed parsing of modification input

2011-09-02  frankmorgner

	* [r521] src/ccid.c: - new pin was not included in apdu for pin
	  modification (fixed) - added support for
	  modification/verification apdus from the host that don't contain
	  any data. the reader automatically allocates the correct number
	  of bytes for the pin(s) and modifies apdu's case and lc.

	* [r520] README.dox, src/ccid.c, src/ccid.h: fixed problems parsing
	  pin modification data structure

	* [r519] src/cats-test.c, src/ccid.c: fixed bugs for pin
	  modification

	* [r518] patches/ccid-1.4.4.patch: fixed bug stating insufficient
	  buffer

	* [r517] src/cats-test.c, src/ccid.c, src/usb.c: fixed bugs due to
	  new version of opensc

2011-08-30  frankmorgner

	* [r511] configure.ac, src/Makefile.am, src/cats-test.c,
	  src/ccid.c, src/sslutil.c, src/sslutil.h: - added openssl debug
	  code to ccid emulator - fixed some bugs due to changes in recent
	  opensc version - added support for changing pin via standard
	  leser

2011-08-09  frankmorgner

	* [r488] patches/ccid-1.4.4.patch: patch to newest version of
	  libccid

2011-08-08  frankmorgner

	* [r481] src/usb.c: returning default strings on selection of wrong
	  language

2011-08-02  frankmorgner

	* [r476] src/cats-test.c: fixed potential buffer overflow when
	  parsing input

2011-07-28  oepen

	* [r442] README.dox: Fixed some typos

2011-07-28  frankmorgner

	* [r441] configure.ac: fixed configure with pace

2011-07-27  frankmorgner

	* [r440] .:

2011-07-25  frankmorgner

	* [r433] ., configure.ac, src, src/ccid.c: switched to opensc
	  0.12.1, where build_apdu has been accepted as sc_bytes2apdu

	* [r432] src/ccid.c: added support for GetReaderInfo of BSI
	  TR-03119

	* [r431] src/ccid.c: - bugfix to be conform to OpenPACE API - added
	  consistency checks for lengths of APDUs

2011-07-23  frankmorgner

	* [r427] configure.ac: silent build rules

2011-02-08  frankmorgner

	* [r415] ChangeLog, configure.ac: released 0.5

	* [r414] src, src/opensc[DEL]: fixed generation of distribution
	  file

	* [r413] src/ccid.c: adapted to the latest changes of libnpa

	* [r411] src/binutil.c: added mingw compatibility

2011-02-02  frankmorgner

	* [r404] configure.ac, src/Makefile.am: building clean distribution
	  file

	* [r403] configure.ac, src/Makefile.am, src/ccid.c, src/ccid.h,
	  src/scutil.h, src/usb.c: renamed libpace to libnpa

2011-02-01  frankmorgner

	* [r402] src, src/opensc: getting opensc only once

2011-01-31  frankmorgner

	* [r394] README.dox, configure.ac, src, src/Makefile.am: linking
	  against opensc now as shared library

2011-01-16  frankmorgner

	* [r391] src/Makefile.am: - fixed memory corruption when getting
	  ef.cardaccess - minor changes in build process with libopensc

	* [r390] Makefile.am, src/Makefile.am: optimized makefile-targets

2011-01-15  frankmorgner

	* [r389] README.dox, configure.ac, src/Makefile.am: - added
	  customization via OPENSC_CONFIGURE - changed information
	  regarding opensc - fixed pkg-config file

	* [r387] src/ccid.c, src/usb.c: - fixed problem when powering the
	  card - removed unused code that had to do with slot-complexity

2011-01-14  frankmorgner

	* [r386] src/ccid.c: supporting only one slot due to new opensc
	  limitations

	* [r385] configure.ac, src/Makefile.am, src/ccid.c, src/ccid.h:
	  switched to opensc.0.12.0. note that this has some issues when
	  linking against both libnpa and the opensc libraries at the same
	  time. readme information would be usefull for this...

2010-12-13  frankmorgner

	* [r383] src/cats-test.c: type of secret can be specified via
	  command line

2010-12-11  frankmorgner

	* [r379] README.dox: fixed configure command

	* [r378] README.dox: - updated information

2010-12-10  frankmorgner

	* [r377] src/pcscutil.c: fixed build with pcsc-lite

	* [r376] src/cats-test.c, src/pcscutil.c: Fix build with visual
	  studio

2010-12-08  frankmorgner

	* [r375] src/ccid.c: adapted to the latest changes of libpace

	* [r370] ChangeLog, configure.ac: releasing 0.4

2010-12-07  frankmorgner

	* [r368] README.dox: updated information

	* [r367] src/scutil.h: added missing file

	* [r366] configure.ac, src/scutil.h[DEL]: linking against libopensc
	  not easily possible. we need to remove this dependancy

2010-11-22  frankmorgner

	* [r365] src/cats-test.c, src/pcscutil.c, src/pcscutil.h: fixed
	  compiling for windows

2010-11-15  frankmorgner

	* [r361] src/Makefile.am, src/ccid.c, src/scutil.h, src/sm.c[DEL]:
	  removed/replaced remains of libpace

	* [r360] configure.ac: not building cats-test by default.

2010-11-14  frankmorgner

	* [r359] Makefile.am, configure.ac, libpace.pc.in[DEL],
	  src/Makefile.am, src/pace[DEL], src/pace-tool.c[DEL],
	  src/pace.c[DEL], src/pace_lib.c[DEL], src/scutil.c, src/sm.c:
	  extracted libpace from ccid

2010-10-28  frankmorgner

	* [r347] README.dox: updated support information

	* [r346] README.dox, apdus, src/pace-tool.c: - fixed: pace-tool
	  dumped wrong apdu buffer - updated documentation on opensc

2010-10-27  frankmorgner

	* [r345] src/pace-tool.c, src/scutil.c: - cleaned (debug) output -
	  fixed error in interactive mode of pace-tool

	* [r344] src/ccid.c, src/pace.c: pace card supports extended
	  lengths. note that we really need a card driver which covers that

	* [r343] Makefile.am, README.dox, apdus, src/pace-tool.c: plaintext
	  apdus to be sent via SM can now be read from a file

2010-10-26  frankmorgner

	* [r341] src/binutil.c, src/ccid.c, src/pace-tool.c, src/scutil.c,
	  src/usb.c: unified usage of sizeof. found some potential memory
	  corruptions with that.

	* [r340] src/ccid.c, src/scutil.c, src/usb.c: - fixed memory
	  corruption on card initialization - fixed compilation warning

2010-10-22  frankmorgner

	* [r339] src/ccid.c: added workaround for ausweisapp

2010-10-21  frankmorgner

	* [r338] src/ccid.c, src/pace.c: fixed formating of
	  ReadersPACECapabilities result. errors were due to changes of
	  r284

	* [r337] src/ccid.c, src/pace.c: - enable extended length apdu for
	  all cards that have an ef.cardaccess - set the bit for esign by
	  default (for testing only)

2010-10-15  frankmorgner

	* [r334] src/Makefile.am, src/binutil.c, src/binutil.h,
	  src/pace/scutil.h, src/scutil.c, src/usb.c: - moved
	  OpenSC-related functions to scutil - added make-target for
	  flawfinder (to be used with vim)

2010-10-14  frankmorgner

	* [r331] src/usb.c: added command line option for gadgetfs
	  mountpoint

2010-10-13  frankmorgner

	* [r330] Makefile.am, configure.ac: switched from automake to sed
	  for substitution of automake variables

2010-10-11  frankmorgner

	* [r317] src/pace.c: added argument checking

	* [r316] src/binutil.c, src/ccid.c, src/pace.c, src/scutil.c,
	  src/sm.c: reviewed files with flawfinder

2010-10-07  frankmorgner

	* [r300] src/cats-test.c, src/pcscutil.c, src/pcscutil.h: -
	  cats-test and picc_to_pcsc are using the same pcsc abstraction.
	  this reduces the code to maintain - partial rewrite of
	  picc_to_pcsc to reduce memory leaks and add fault tolerancy

2010-10-06  frankmorgner

	* [r299] src/Makefile.am, src/cats-test.c, src/pcscutil.c,
	  src/pcscutil.h: prepare to merge with pcsc_to_picc

2010-10-04  frankmorgner

	* [r297] Doxyfile.in, README.dox: added missing files

	* [r296] src/ccid.h, src/usb.c: using strtol instead of sscanf

	* [r295] src/usb.c: - added command line parameter for USB
	  iInterface, use it to fool AusweisApp - fixed population of event
	  notification status - dont initialize serial number, when given
	  in input

	* [r294] README: added README as link to doxygen file

	* [r293] Makefile.am, README[DEL], src/usb.c: only using doxygen
	  description as readme

2010-10-02  frankmorgner

	* [r292] Doxyfile[DEL], Makefile.am, configure.ac, doxygen.am[DEL],
	  m4/doxygen.m4[DEL]: changed to a more simplistic generation of
	  documentation

2010-10-01  frankmorgner

	* [r291] src/ccid.h, src/pace/pace.h, src/pace/sm.h, src/usb.c:
	  added documentation

2010-09-30  frankmorgner

	* [r290] src/usb.c: sending description about the running
	  configuration via usb descriptor

	* [r289] Doxyfile, Makefile.am, configure.ac, doxygen.am,
	  m4/doxygen.m4, src/ccid.h, src/pace/pace.h, src/pace/pace_lib.h,
	  src/pace/scutil.h, src/pace/sm.h, src/sm.c: added documentation

2010-09-29  frankmorgner

	* [r288] src/cats-test.c, src/ccid.c, src/ccid.h, src/pace.c,
	  src/pace/pace.h, src/pace/sm.h, src/usb.c: added documentation

	* [r287] src/pace.c: adapted to the latest changes of OpenPACE

2010-09-28  frankmorgner

	* [r286] patches/Makefile.am, patches/ccid-1.3.13.patch[DEL],
	  patches/pcsclite_trunk_r5270.patch[DEL]: postpone patch update
	  for higher versions of ccid

	* [r285] patches/ccid-1.3.11.patch, src/ccid.c: forgot writeback to
	  RxBuffer in ccid driver

2010-09-27  frankmorgner

	* [r284] patches/ccid-1.3.11.patch, src/ccid.c, src/pace/pace.h:
	  added support for dynamic pace result generation to be
	  transmitted to the pc/sc client. note that other ccid patches are
	  not up to date

	* [r283] src/pace.c: corrected indent and title of CHAT and
	  certificate description

	* [r282] src/pace.c: added support for printing and transmitting
	  chat

	* [r281] src/pace.c, src/pace/pace.h: print certificate description

	* [r280] src/Makefile.am, src/cats-test.c[CPY],
	  src/cats-tool.c[DEL], src/pace.c, src/pace/pace.h: working on
	  support for certificate description

2010-09-25  frankmorgner

	* [r279] src/pace/sm.h, src/sm.c: deactivate emulators sm context,
	  when host sends sm protected apdus

2010-09-24  frankmorgner

	* [r278] src/cats-tool.c, src/scutil.c: - finished simulation of
	  ta/ca - fixed parsing case 4 extended apdu

	* [r277] src/cats-tool.c, src/sm.c: - fixed pace input parameters
	  of cats-tool - fixed apdu of simulation of ta/ca (cats-tool) -
	  fixed padding removal (sm)

	* [r276] patches/ccid-1.3.11.patch, patches/ccid-1.3.13.patch,
	  patches/pcsclite_trunk_r5067.patch[DEL],
	  patches/pcsclite_trunk_r5270.patch: - updated patch to pcsclite
	  trunk - changed default ccid command buffer size to support
	  sending extended apdus in a single transmit (only for ccid-1.3.11
	  necessary)

2010-09-23  frankmorgner

	* [r275] src/cats-tool.c, src/ccid.c, src/scutil.c: - added le/lc
	  to apdu debugging - fixed byte order problem for
	  PC_to_RDR_XfrBlock - cats-tool: added simulation of part of TA/CA

	* [r274] src/ccid.c, src/pace-tool.c, src/pace.c, src/sm.c: - fixed
	  compiling errors - adjusted secure messaging to support extended
	  length apdus - card has to support extended length, this is
	  hardcoded at the moment, but should better be done in the
	  appropriate card driver

	* [r273] src/ccid.c, src/pace-tool.c: added debugging of invalid
	  apdus

	* [r272] src/pace.c: adatpted to the latest changes of OpenPACE.
	  EstablishPACEChannel now fully functional

2010-09-21  frankmorgner

	* [r271] src/cats-tool.c: - fixed receive length - added simulation
	  of buergerclient/ausweisapp

2010-09-20  frankmorgner

	* [r270] src/ccid.c: - removed unnecessary checks of NULL pointer
	  before using free() - fixed memory leak for buergerclient
	  workaround

2010-09-19  frankmorgner

	* [r269] src/scutil.c: fixed case 2 extended apdu parsing

2010-09-18  frankmorgner

	* [r268] src/ccid.c, src/ccid.h, src/usb.c: - extended length fully
	  functional. fixed last problems with lengths and ccid descriptor.

2010-09-16  frankmorgner

	* [r267] src/scutil.c: bugfix: case 2 extended length apdu are now
	  recognized

2010-09-15  frankmorgner

	* [r266] src/ccid.c, src/scutil.c, src/usb.c: - Added capabilities
	  to parse and send extended length APDUs. This does not work
	  proberly with libccid, so it is disabled at the moment - unpower
	  card only on PC_to_RDR_IccPowerOff

	* [r265] src/ccid.c, src/pace-tool.c: reset the card before
	  disconnecting to unpower and reset the secure messaging status

2010-09-14  frankmorgner

	* [r264] src/ccid.c, src/pace-tool.c, src/pace.c, src/pace/sm.h,
	  src/sm.c: - some unneded functions are no longer available in
	  header files - cleaned memory leaks in pace-tool and
	  ccid-emulator

	* [r263] src/cats-tool.c: - fixed wrong PCSC-PACE-data - fixed
	  command line parsing

2010-09-13  frankmorgner

	* [r262] src/pace.c, src/pace/pace.h: added support for unambiguous
	  PACE-channel selection (ID.icc and ID.pcd)

	* [r261] src/ccid.c: fixed memory corruption for too long
	  _RDR_to_PC_DataBlock packages

2010-09-09  frankmorgner

	* [r260] src/cats-tool.c, src/usb.c: bugfix: wrong format strings

2010-09-01  frankmorgner

	* [r259] configure.ac, src/Makefile.am, src/cats-tool.c[CPY],
	  src/ccid-test.c[DEL]: - renamed ccid-test to cats-tool, since it
	  is suitable for all readers of type cat-s and cat-b - cats-tool
	  takes PIN as input parameter

2010-08-31  frankmorgner

	* [r258] src/ccid-test.c: - bugfix: pace output data now parsed
	  correctly - added time measurement

	* [r257] src/ccid-test.c: removed PCSC_TLV_STRUCTURE since its the
	  attributes are not always packed

	* [r256] configure.ac, src/ccid-test.c: - bugfix: now converting
	  pace io control to host byte order - now parsing pace output data
	  - use pcsclite-capabilities, if possible

2010-08-30  frankmorgner

	* [r255] src/ccid-test.c: including reader.h, if possible

	* [r254] src/ccid-test.c: added compatibility with windows

2010-08-25  frankmorgner

	* [r253] configure.ac, libpace.pc.in: added missing file

	* [r252] src/pace-tool.c: added pace-tool can now break can, pin,
	  puk with brute force

2010-08-24  frankmorgner

	* [r251] configure.ac, src/ccid.c, src/pace.c, src/pace/pace.h:
	  added workaround for current buergerclient to read efcardaccess

2010-07-15  frankmorgner

	* [r223] Makefile.am, configure.ac, patches/Makefile.am,
	  src/Makefile.am, src/ccid.c, src/pace, src/pace.h[DEL],
	  src/pace/pace.h[CPY], src/pace/pace_lib.h[CPY],
	  src/pace/scutil.h[CPY], src/pace/sm.h[CPY], src/pace_lib.h[DEL],
	  src/scutil.h[DEL], src/sm.h[DEL]: - made establishpacechannel
	  output independant from any byte order conversion. little endian
	  handling is done by the ccid-part. - pacelib exports
	  PACE-functionality.

2010-07-12  frankmorgner

	* [r217] src/ccid.c, src/usb.c: - usb.c: fixed signal handling -
	  ccid.c: revised construction of RDR_to_PC_*-packages to make the
	  code more readable

	* [r215] src/ccid.c, src/pace-tool.c, src/pace.c, src/pace.h: -
	  made establishpacechannel output independant from any byte order
	  conversion. little endian handling is done by the ccid-part.

	* [r211] patches/ccid-1.3.11.patch, patches/ccid-1.3.13.patch,
	  patches/pcsclite_trunk_r5067.patch: bugfix: transform pace output
	  buffer on usb from little endian to host byte order

	* [r210] patches/ccid-1.3.11.patch, patches/ccid-1.3.13.patch,
	  patches/pcsclite_trunk_r5063.patch[DEL],
	  patches/pcsclite_trunk_r5067.patch: - fixed parse errors

	* [r209] patches/Makefile.am, patches/ccid-1.3.11.patch,
	  patches/ccid-1.3.13.patch, src/ccid.c, src/pace-tool.c,
	  src/pace.c, src/pace.h: - pace debug output of libccid is shown
	  by default in pcscd's log - made establishpacechannel input
	  independant from any byte order conversion. little endian
	  handling is done by the ccid-part.

2010-07-07  frankmorgner

	* [r202] patches/ccid-1.3.11.patch, patches/ccid-1.3.13.patch,
	  patches/pcsclite_trunk_r5063.patch, src/pace.c: - added support
	  for IDicc - fixed parse error of pace output buffer

	* [r201] patches/ccid-1.3.11.patch, patches/ccid-1.3.13.patch,
	  patches/pcsclite_trunk_r4993.patch[DEL],
	  patches/pcsclite_trunk_r5063.patch: - added parsing of PACE data
	  - bugfix: PACE output data had to be wrapped again

2010-07-05  frankmorgner

	* [r195] patches/ccid-1.3.11.patch, patches/ccid-1.3.13.patch,
	  patches/pcsclite_trunk_r4993.patch: bugfix: PACE response data
	  was not copied to application

2010-07-04  frankmorgner

	* [r194] src/ccid-test.c: printing received buffers

	* [r193] patches/ccid-1.3.11.patch, patches/ccid-1.3.13.patch,
	  patches/pcsclite_trunk_r4993.patch: bugfix: get the whole PACE
	  response data

	* [r192] src/ccid.c, src/pace.c, src/usb.c: - added information how
	  many bytes were actually transmitted via usb - split general
	  authenticate into multiple functions, one for every step of PACE.
	  - including recent and previous car in output buffer of
	  EstablishPACEChannel - ccid-emulator initiates
	  EstablishPACEChannel always with a new sm_ctx

2010-07-02  frankmorgner

	* [r191] src/pace.c: added ef.cardaccess and statusbytes to
	  response of establishpacechannel

	* [r190] src/ccid.c, src/pace.c: fixed wrong text of prompt for
	  secret

2010-07-01  frankmorgner

	* [r184] ChangeLog: really releasing 0.3

	* [r182] Makefile.am: fixed missing Makefile to include patche

	* [r181] Makefile.am, configure.ac, patches/Makefile.am: added
	  patches to distribution file

	* [r180] ChangeLog, configure.ac: releasing 0.3

	* [r179] src/pace-tool.c, src/pace.h: - fixed unblock pin, it is
	  now successfully tested

2010-06-25  frankmorgner

	* [r170] src/ccid.c, src/pace.c, src/pace.h: - Replaced references
	  to sc_get_pin* with its OpenSSL counter parts (untested) - UI
	  functionality and maybe more is no longer shipped in
	  opensc>=0.12. This and the fact that linking against libopensc in
	  general is discouraged might be a reason to abandon opensc in
	  future releases.

2010-06-23  oepen

	* [r169] patches/ccid-1.3.11.patch, patches/ccid-1.3.13.patch,
	  patches/pcsc-lite-1.5.5.patch, patches/pcsc-lite-1.6.1.patch:
	  -Fixed patches so bitbake can apply them -Added patches to
	  bitbake recipes

2010-06-23  frankmorgner

	* [r168] src/ccid.c, src/usb.c: - better (or at least some) signal
	  handling - always checking the existance of a card, when
	  requested

2010-06-22  frankmorgner

	* [r166] src/ccid.c, src/ccid.h, src/usb.c: - restructured handling
	  of interrupt thread to kill the thread along with all the others
	  - fixed error on input parameter parsing when interrupt is
	  activated - completed interrupt signaling for new/removed cards

	* [r162] src/ccid.c, src/ccid.h, src/usb.c: forcing empty parameter
	  list with function(void) instead of unspecified parameter list
	  with function()

2010-06-21  frankmorgner

	* [r161] src/ccid.c, src/pace.c, src/scutil.c, src/sm.c: - made
	  debugging of openssl errors human readable - removed debugging of
	  return values, added human readable messages instead

2010-06-20  frankmorgner

	* [r160] patches/ccid-1.3.13.patch, patches/pcsc-lite-1.6.1.patch:
	  added patches for newer versions of ccid and pcsc-lite

	* [r159] patches, patches/ccid-1.3.11.patch,
	  patches/pcsc-lite-1.5.5.patch,
	  patches/pcsclite_trunk_r4993.patch[CPY],
	  pcsclite_trunk.patch[DEL]: added patches for distribution
	  packages of ccid and pcsc-lite

2010-06-19  frankmorgner

	* [r157] src/pace-tool.c, src/pace.c: - pace-tool: fixed length of
	  input buffer for EstablishPACEChannel - added debug messages to
	  pace.c

	* [r156] Makefile.am, pcsclite_trunk.patch, src/ccid-test.c,
	  src/ccid.c, src/ccid.h, src/pace-tool.c, src/pace.c, src/pace.h,
	  src/usb.c: - added patch to distribution package - changed
	  debug_sc_result to be a define. this now gets the line of code
	  correct - added checking for input length to functions that parse
	  the bulkin buffer - fixed segfault for GetReadersPACECapabilities
	  when no card is inserted - added length checking of input for
	  EstablishPACEChannel - ccid-test: fixed pbSendBufferEstablish -
	  pcsclite_trunk.patch: - fixed parsing of
	  lengthCertificateDescription - fixed wrong bPINOperation for pace
	  capabilities and execute pace

2010-06-18  frankmorgner

	* [r155] pcsclite_trunk.patch, src/ccid-test.c, src/ccid.c: -
	  renamed Special PIN Verification/Capabilities to PACE
	  Verification/Capabilities - fixed PIN PACE support in ccid
	  descriptor - using uint16_t instead of WORD in PACE structures -
	  fixed lengthInputData to host byteorder - fixed parsing input
	  buffer of SCardControl with FEATURE_EXECUTE_PACE - parsing input
	  buffer for PACE verification and adjusting the byteorder - added
	  30s timeout to for PACE verification - triggering PACE via PC/SC
	  now works although quite unstable

	* [r154] pcsclite_trunk.patch, src/ccid-test.c, src/ccid.c: -
	  ccid-emulator: propagating PACE capabilities to ccid descriptor
	  of - ccid-test: IOCTL_FEATURE_IFD_PIN_PROPERTIES is currently
	  hardcoded and should be replaced by the value from
	  GET_FEATURE_REQUEST - pcsclite_trunk.patch: fixed propagation of
	  data from SCardControl to SecurePINSpecialVerify and
	  SecurePINSpecialCapabilities

2010-06-17  frankmorgner

	* [r153] configure.ac, src/Makefile.am, src/ccid-test.c: added
	  ccid-test to evaluate the PACE features of ccid-emulator
	  (untested)

2010-06-16  frankmorgner

	* [r152] configure.ac, pcsclite_trunk.patch, src/Makefile.am,
	  src/ccid.c, src/pace.c, src/sm.c, src/sm.h: added PACE features
	  to ccid-emulator (untested)

2010-06-10  frankmorgner

	* [r146] src/pace-tool.c, src/pace.c: - implemented passing a CHAT
	  to the card. - note that the type PACE_CHAT should be integrated
	  into OpenPACE - added parameters for passing CHAT and certificate
	  description to pace-tool

2010-06-09  frankmorgner

	* [r143] configure.ac, src/Makefile.am: renamed ccid to
	  ccid-emulator to avoid conflicts with libccid

	* [r141] Makefile.am, src/Makefile.am: added missing files for
	  distribution packages

2010-06-05  frankmorgner

	* [r132] ChangeLog: updated checksums, install files for recipes.
	  updated log files for 0.6.1

	* [r131] src/pace-tool.c, src/pace.c, src/pace.h, src/sm.c,
	  src/sm.h: - dropped pace_transmit_apdu in favour of a solution
	  with sm_transmit_apdu. post_transmit and pre_transmit can be used
	  to perform actions before encrypting/decrypting a sm apdu (such
	  as incrementing the ssc for pace). - fixed ssc problems.
	  encrypted communication with more than one apdu (e.g. resuming
	  the pin) is now working. - fixed uninitialized pointer in
	  sm_decrypt

2010-06-04  frankmorgner

	* [r130] src/sm.c: fixed uninitialized pointer which caused
	  segfault on decryption.

	* [r129] src/pace.c: fixed segfault if ef.cardaccess is not
	  readable

2010-06-03  frankmorgner

	* [r128] src/sm.c: added error messages

	* [r127] src/pace-tool.c: bugfix for conversion of hex to binary
	  for interactive mode

2010-06-02  frankmorgner

	* [r125] README, src/pace-tool.c: added information about the
	  environment variables used

	* [r124] src/pace-tool.c: pace-tool can now read secrets from
	  environment variables

	* [r123] src/pace-tool.c: made pin puk can or mrz an optional
	  command line argument

	* [r122] src/pace-tool.c: fixed precision of time measurement

	* [r121] src/pace-tool.c: added time measurement for a PACE run

2010-06-01  frankmorgner

	* [r119] src/pace-tool.c: establish pace channel and exit, when no
	  further commandline option is given

	* [r118] src/pace-tool.c: - added switch to enable apdu translating
	  (disabled by default)

2010-05-26  frankmorgner

	* [r111] src/pace-tool.c, src/pace.c, src/pace.h, src/sm.c: removed
	  some messages, when less verbose. fixed little endian problem
	  when parsing input buffer of EstablishPACEChannel.

2010-05-20  frankmorgner

	* [r110] src/sm.c: fixed class byte generation for sm apdu

	* [r109] src/pace-tool.c, src/pace.c, src/sm.c: - sm_transmit_apdu
	  doesn't check SWs anymore - not throwing error for sw=63XX in
	  mse:set at

	* [r108] src/pace-tool.c, src/pace.c, src/pace.h, src/sm.c: - using
	  short apdus for mse:set at and generic authenticate. to make it
	  work with the sm implementation - added parameter oldpacectx to
	  EstablishPACEChannel to allow a a new PACE connection inside an
	  exitsting PACE connection (the output buffer of the latter
	  connection must be provided since it stores the ef.cardaccess) -
	  added functionality to ask for the secret in
	  pace_reset_retry_counter - added macro pace_change_pin - SWs were
	  stored at the wrong place of the output buffer from
	  EstablishPACEChannel, fixed. - split up functionality of
	  pace_test into multiple functions - added new command line option
	  to pace-tool to resume the pin. resuming the pin is not working,
	  yet.

2010-05-18  oepen

	* [r107] src/pace.c: Changed EXPLICIT tagging of CHAT and auxiliary
	  authenticated data to IMPLICIT tagging

2010-05-16  frankmorgner

	* [r106] src/pace-tool.c, src/pace.c, src/pace.h: - Added handling
	  for output buffer of EstablishPACEChannel, but CARs are still
	  missing - Handed over code for handling of IV and SSC for PACE to
	  OpenPACE

2010-05-08  frankmorgner

	* [r101] configure.ac: added maintainer

	* [r100] src/scutil.c, src/scutil.h, src/sm.c, src/sm.h: moved
	  bin_log to scutil

	* [r99] README: updated informations about pace-tool

2010-05-07  frankmorgner

	* [r98] configure.ac: corrected configure output

	* [r96] INSTALL[DEL], configure.ac: removed unmodified file

	* [r95] src/pace.c: added _essential_ missing file

	* [r94] Makefile.am: added missing file

	* [r93] ChangeLog, INSTALL, Makefile[DEL], NEWS, binutil.c[DEL],
	  binutil.h[DEL], ccid.c[DEL], ccid.h[DEL], configure.ac, m4,
	  m4/Makefile.am, m4/acx_pthread.m4, pace-tool.c[DEL], pace.c[DEL],
	  pace.h[DEL], pace_lib.c[DEL], pace_lib.h[DEL], scutil.c[DEL],
	  scutil.h[DEL], sm.c[DEL], sm.h[DEL], src, src/Makefile.am,
	  src/binutil.c[CPY], src/binutil.h[CPY], src/ccid.c[CPY],
	  src/ccid.h[CPY], src/pace-tool.c[CPY], src/pace.h[CPY],
	  src/pace_lib.c[CPY], src/pace_lib.h[CPY], src/scutil.c[CPY],
	  src/scutil.h[CPY], src/sm.c[CPY], src/sm.h[CPY], src/usb.c[CPY],
	  src/usbstring.c[CPY], src/usbstring.h[CPY], usb.c[DEL],
	  usbstring.c[DEL], usbstring.h[DEL]: fixed include in pace.c.
	  switched to autotools

2010-05-05  frankmorgner

	* [r92] Makefile, binutil.c[CPY], binutil.h[CPY], ccid.c,
	  pace-tool.c, scutil.c, scutil.h, usb.c, util.c[DEL], util.h[DEL]:
	  split up utils into stuff for program and sc handling

2010-05-04  frankmorgner

	* [r91] pace-tool.c, pace.c, pace.h: cleaned up pace.c and moved
	  test_pace to pace-tool.c

	* [r90] Makefile, pace-tool.c, pace.c: openpace is now a hard
	  dependancy for pace-tool. ccid does not yet depend on pace, since
	  the USB interface to pace is not yet defined.

	* [r89] Makefile, ccid.c, ccid.h, pace-tool.c, pace.c, usb.c,
	  util.c, util.h: cleaned up command line options of pace-tool and
	  made it independant from ccid

	* [r88] pace.c, sm.c: bugfix: initializing apdu in pace_gen_auth.
	  bin_log now checks input data.

	* [r87] pace.c: changed length of read binary apdu to support acr
	  122

2010-05-03  frankmorgner

	* [r86] Makefile, pace-tool.c, usb.c, util.c, util.h: put static
	  pace functionality into the new program pace-tool

	* [r85] pace.c: the number of remaining retries is a warning from
	  the card, not a fatal error

2010-04-29  frankmorgner

	* [r84] pace.c: using proper type for getline result

2010-04-28  frankmorgner

	* [r83] ccid.c, ccid.h, pace.c, pace.h, usb.c: added support for
	  changing CAN and PIN for PACE

2010-04-27  frankmorgner

	* [r82] INSTALL: updated instructions

	* [r81] Makefile, ccid.c, pace.c, sm.c, usb.c: - sm will yield
	  error when the class byte indicates a sm apdu and pace will
	  simply transmit the apdu without encrypting/authenticating it. -
	  fixed building process when compiling without pace

2010-04-19  frankmorgner

	* [r80] Makefile, ccid.c, ccid.h, usb.c: added option to select
	  card driver. beautified usage dialog.

2010-04-16  frankmorgner

	* [r79] Makefile: improved build process

	* [r78] usb.c: improved option parsing

	* [r77] ccid.c, ccid.h, usb.c: added option to scan for available
	  readers

2010-04-15  frankmorgner

	* [r76] Makefile, pace.h, pace_lib.c, pace_lib.h: added header file
	  for pace library functions

	* [r75] Makefile, README, apdu.c[DEL], apdu.h[DEL], pace.c, sm.c: -
	  added information about opensc - using sc_transmit_apdu instead
	  of my_transmit_apdu. fixing the opensc error is the better
	  solution than implementing it twice (see
	  http://www.opensc-project.org/opensc/ticket/209)

	* [r74] README: updated information

	* [r73] README, ccid.c, ccid.h, pace.c, pace.h, sm.c, sm.h, usb.c:
	  - Fixed error when testing pace without card - Testing pace
	  allows now to choose the type of the secret (mrz, pin, can, puk).
	  The secret can be given as commandline option or interactively. -
	  Cleaned prompt for getting the password - Fixed error when
	  inserting an empty password - When PACE is successfully finished,
	  APDUs for testing can be given interactively

2010-04-13  frankmorgner

	* [r72] pace.c, pace.h, sm.c: - completed mac verification. sm with
	  pace is now fully functional. - made pace_test more fault
	  tolerant.

2010-04-12  frankmorgner

	* [r71] pace.c, sm.c: - decryption of sm apdu now working.
	  verification of mac still missing.

	* [r70] ccid.c, pace.c, sm.c, usb.c: fixed various memory leaks and
	  potential segfaults

	* [r69] pace.c, pace.h, pace_lib.c: - protocol nid in pace_sm_ctx
	  is not needed any longer due to the changes of OpenPACE

	* [r68] pace.c, sm.c: bugfixes: - sm.c: fixed mac data padding,
	  when sending sm apdu without data. - pace.c: for iv calculation
	  ecb is used instead of cbc - pace.c: fixed ssc incrementation

	* [r67] pace.c, pace.h: - trying new apdu to reset retry counter in
	  pace_test - added pace wrapper for sm_transmit_apdu which
	  automatically increments the ssc

	* [r66] pace.c: added missing include

	* [r65] pace.c: added code for reading cardsecurity

	* [r64] sm.c: - reverted changes from last commit

	* [r63] sm.c: - added more debugging - bugfix: header of sm apdu is
	  authenticated instead of the original apdu

2010-04-11  frankmorgner

	* [r62] pace.c: bugfix: fetching unhandled error in update_iv

	* [r61] sm.c, sm.h: made bin_log more verbose

	* [r60] pace.c, pace.h, pace_lib.c, sm.c: Bugfixes: - ssc is a
	  BIGNUM, since its size can be up to 16 bytes (not 16 bits as
	  before) - protected le is now encoded as octet string (not as
	  unsigned integer anymore) - sc_format_asn1_entry was fet with
	  wrong pointers (lebuf instead of *lebuf and formatted_data
	  instead of *formatted_data
	  
	  Added some debug output.

2010-04-10  frankmorgner

	* [r59] sm.c, sm.h: made sm code independant from openssl

	* [r58] ccid.c, pace.c, sm.c, sm.h: - pace.c: removed unused
	  variable ssc - pace.c: bugfix: don't increment ssc when resetting
	  it. - sm.c/.h: wrote wrapper sm_transmit_apdu - sm.c: removed sm
	  error handling, should be done by sc_check_sw -
	  sm.c/ccid.c/pace.c: added qualifier "static" to local functions

	* [r57] pace.c, sm.c, sm.h: added sw checking for sm

	* [r56] pace.c, sm.c: added missing return buffer for select of
	  CardSecurity

	* [r55] pace.c, pace.h, sm.c: - sm.c (sm_encrypt) fixed header of
	  sm apdu - pace.c (EstablishPACEChannel) Fixed initialisation of
	  authentication_ctx. (pace_test) Fixed usage of SC_TEST_RET and
	  initialisation of select apdu for EF.CardSecurity.

2010-04-09  frankmorgner

	* [r54] Makefile, apdu.h, ccid.c, ccid.h, pace.c, pace.h,
	  pace_lib.c, sm.c, sm.h, utils.c[DEL], utils.h[DEL]: - Work in
	  progress: Almost finished (hopefully) flexible sm implementation
	  (untested). struct sm_ctx needs external cipher and
	  authentication implementations. Here only routines for
	  encryption/decryption/authentication with PACE are given.

2010-04-01  frankmorgner

	* [r53] ccid.c, pace.c, pace.h, sm.h: integrated SM into pace

2010-03-31  frankmorgner

	* [r52] sm.c, sm.h, utils.c, utils.h: - added untested function to
	  decrypt sm - function cipher now always disables automatic
	  padding

2010-03-29  frankmorgner

	* [r51] Makefile, sm.c, sm.h, utils.c, utils.h: - Added an untested
	  SM implementation, currently only with encryption - Added utils
	  from OpenPACE

2010-03-22  frankmorgner

	* [r50] pace.c: adapted latest changes of OpenPACE

2010-03-15  frankmorgner

	* [r49] pace.c: bugfix: corrected types of fields from ASN1_INTEGER
	  to ASN1_OCTET_STRING

	* [r48] pace.c: - adopted the latest changes of OpenPACE - bugfix:
	  created receive buffer before sending general authenticate apdus
	  - added more debug output

2010-03-10  frankmorgner

	* [r47] apdu.c, apdu.h: bugfix

2010-03-09  frankmorgner

	* [r46] pace.c: using specifications from TR-03110 2.01 as default
	  (as done by test cards)

	* [r45] Makefile: bugfix: building with apdu.c apdu.h

2010-03-08  frankmorgner

	* [r44] apdu.c, apdu.h, pace.c: - bugfix: general authenticate
	  response data is now encapsulated in a dynamic data object -
	  added more debug messages - bugfix: get_ef_card_access didn't
	  fetch the whole file - bugfix: set mse set at apdu type to case 3
	  - bugfix: only send the plain value (without tag/length) of the
	  PACE_MSE_SET_AT object - bugfix: fixed general authenticate cla
	  byte and set apdu type to case 4 - sanity checks in
	  sc_transmit_apdu forbid the required apdu format of general
	  authenticate so it had to be reimplemented in my_transmit_apdu.
	  apdu.c/apdu.h are mainly copied from opensc.

2010-03-05  frankmorgner

	* [r43] pace.c, pace.h: - fixed includes - fixed return value from
	  pace_test if NO_PACE is defined

	* [r42] ccid.c, ccid.h, pace.c, pace.h, usb.c: - pace-testing is
	  not done in threads anymore, program exits when test is finished
	  - bugfix in debug_ossl - more generic aproach to select
	  EF.CardAccess - EF.CardAccess is read sequencially, to get a
	  correct send sequence counter

2010-03-01  frankmorgner

	* [r41] ccid.c, ccid.h, pace.c, pace.h, usb.c: - bugfix: moved
	  ASN.1 declaration of PACE-APDUs to pace.c - added
	  commandline-option to test PACE currently with hard coded secret
	  etc.

2010-02-28  frankmorgner

	* [r40] INSTALL, Makefile, README, ccid.c, pace.c, pace.h: Added
	  support for Password Authenticated Connection Establishment
	  (PACE) using OpenPACE
	  (http://sourceforge.net/projects/openpace/). Since it is
	  currently untested, it is disabled by default.

2010-01-31  frankmorgner

	* [r37] usb.c: - implemented option parsing with getopt_long

	* [r36] ccid.c: - Some minor code improvements: catch and fix some
	  rare errors, taking more usage of opensc debugging methods,
	  removed not needed variables and code fragments

2010-01-30  frankmorgner

	* [r34] ccid.c, usb.c: - fixed segmentation fault, ccid running
	  stable now again

	* [r33] ccid.c: - switched to opensc's debugging function in log.h
	  - a segmentation fault of unknown origin crashes ccid after too
	  many operations. last stable version is revision 29.

	* [r32] ccid.c: - created detect_card_presence to avoid limitations
	  of sc_detect_card_presence

2010-01-29  frankmorgner

	* [r31] ccid.c, ccid.h, usb.c: - added functions for simplified
	  debugging - changed functions to pass pointers instead of structs
	  and using realloc instead of malloc to reduce memory
	  overhead/usage - changed functions to return opensc-errors to
	  pass printout-debugging to the top level - included functionality
	  of get_RDR_to_PC_Parameters in perform_PC_to_RDR_GetParamters

2010-01-24  frankmorgner

	* [r29] ccid.c, ccid.h: added support for bNumberMessage

2010-01-23  frankmorgner

	* [r28] ccid.c: added support for flags in bConfirmPIN

	* [r27] ccid.c: added support for pin modification

	* [r26] ccid.c, ccid.h, usb.c: - added defines for pin modification
	  - debugging apdu and rapdu there where they are created -
	  splitted pin block operations into several functions

2010-01-21  frankmorgner

	* [r23] Makefile, ccid.c, ccid.h, usb.c: - switched from libpcsc to
	  libopensc. This brings some new features: - Support for 4 slots
	  per reader - abstraction of user interface - interactive pin
	  verification - BCD encoding of PIN - Support for new readers
	  (OpenCT) - automatically skip to a reader with a card - added
	  defines - changed interface of ccid_initialize

2010-01-14  frankmorgner

	* [r22] ccid.c, ccid.h, usb.c: changed naming

	* [r21] usb.c: removed not needed iso-identifier

	* [r20] Makefile, ccid.c, ccid.h, usb.c: code split into multiple
	  files, added include guards

2010-01-12  frankmorgner

	* [r17] ccid.h: perform_PC_to_RDR_Secure works, read actual PIN is
	  still missing

2010-01-10  frankmorgner

	* [r16] ccid.h: added support for pinpad. doesn't work atm, somehow
	  abPINApdu is wrong.

2010-01-05  frankmorgner

	* [r11] ccid.c, ccid.h: changed vendorid/productid, added new
	  structures for future PIN support.

2010-01-04  frankmorgner

	* [r8] ccid.c: Cleaned up warnings.

	* [r6] ccid.bb[DEL]: Separated bitbake recipes. vscarchitecture.bb
	  simply collects the other recipes now.

2009-08-06  schertz123456

	* [r1] ., AUTHORS, COPYING, INSTALL, Makefile, README, ccid.bb,
	  ccid.c, ccid.h, usbstring.c, usbstring.h: Initial commit.

